using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Davs;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.Davs
{
    public interface IProductStorageDavRepository
    {
        Task<BaseResult> Add(ProductStorageDavElastic ProductStorageDav);

        Task<BaseResult> AddManyAsync(IEnumerable<ProductStorageDavElastic> ProductStorageDavs);

        Task<BulkResponse> DeleteProductStorageDavs(IEnumerable<ProductStorageDavElastic> ProductStorageDavs);

        Task<DeleteByQueryResponse> DeleteProductStorageDavsByQuery(IEnumerable<long> ids);

        Task<SmartTableResult<ProductStorageDavElastic>> SearchForExcel(BoolQueryDescriptor<ProductStorageDavElastic> query);

        Task<SmartTableResult<ProductStorageDavElastic>> GetByIds(List<long> ids);

        Task<SmartTableResult<ProductStorageDavElastic>> Search(BoolQueryDescriptor<ProductStorageDavElastic> query, int count);
    }

    public class ProductStorageDavRepository : IProductStorageDavRepository
    {
        private readonly ElasticIndex<ProductStorageDavElastic> _dbContext;

        public ProductStorageDavRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ProductStorageDavElastic>(settings.Value.ClusterUrl, "productstoragedav");
        }

        #region search

        public async Task<SmartTableResult<ProductStorageDavElastic>> SearchForExcel(BoolQueryDescriptor<ProductStorageDavElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<ProductStorageDavElastic>> Search(BoolQueryDescriptor<ProductStorageDavElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }

        #endregion search

        #region Add order

        public async Task<BaseResult> Add(ProductStorageDavElastic ProductStorageDav)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(ProductStorageDav);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<ProductStorageDavElastic> ProductStorageDavs)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(ProductStorageDavs);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteProductStorageDavs(IEnumerable<ProductStorageDavElastic> ProductStorageDavs)
        {
            return await _dbContext.DeleteMany(ProductStorageDavs);
        }

        public async Task<DeleteByQueryResponse> DeleteProductStorageDavsByQuery(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        public async Task<SmartTableResult<ProductStorageDavElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<ProductStorageDavElastic>();
            var idsQ = new QueryContainerDescriptor<ProductStorageDavElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        #endregion Add order
    }
}